#! /home/song3/anaconda3/bin/python


import numpy as np
from matplotlib import pyplot as plt
import sys, struct
import os.path
import warnings
warnings.simplefilter('ignore')

from bitio import bit_open
from bitarray import bitarray


def readFile(filename):
    ret = []
    with bit_open(filename, "r") as f:
         while True:
            try:
                num = f.read_bits(2)
            except:
                break
            ret.append(num)

    return ret



def mod(num):
    sync_code = [0,1,2,3,3,2,1,0]
    output = sync_code
    modulation = np.array([1+1j,-1+1j,-1-1j,1-1j])
    for value in num:
        for sample in range(4):
            # output.append(modulation[value])
            # print(value)
            output.append(modulation[0])
            # output.append(modulation[1])
            # output.append(modulation[2])
            # output.append(modulation[3])

    output = np.array(output)
    return output

def addNoise(signal):
    np.random.seed(1234)
    real_noise = np.random.normal(0,0.1,len(signal))
    imag_noise = np.random.normal(0,0.1,len(signal))
    noise = real_noise +1j*imag_noise
    signal += noise 
    return signal


def writeFile(filename,signal):
    # data = complexToSingleArray(signal)
    data = signal.astype(np.complex64)
    # import pdb;pdb.set_trace()
    data.tofile(filename)
    

if __name__ == "__main__":
    numbers = readFile("pic1.jpg")
    signal = mod(numbers)
    # signal = addNoise(signal)
    writeFile("modulated_pic.dat",signal)



